//package htmlstream; //experimental

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
	The "printing queue" for HtmlizableI objects.
	It never accepts twice the same object.
   @author Andrea Trentini, Daniela Micucci
*/
public class HtmlStream implements ActionListener
{
   // Experimental GUI output
   protected JFrame frame;
   protected JEditorPane html;
	protected JButton refresh;

   /**
      the "queue"
   */
   protected Vector objects;

   /**
      if you already have a "root" object to pass...
   */
   public HtmlStream(HtmlizableI o)
   {
      this();
      o.grow(this);
   }

   public HtmlStream()
   {
      objects=new Vector();
   }

	/**
		Used to "queue" an object to this HtmlStream.
		No "expansion" occurs.
	*/
   public boolean add(Object o) // WAS: add(HtmlizableI o)
   {
      if(!objects.contains(o) && o!=null)
      {
         objects.add(o);
         return true;
      }
      else
         return false;
   }

  	/**
		Symmetric of <i>grow()</i> on HtmlizableI.
		Used to "queue" an object to this HtmlStream,
		WITH "expansion".
	*/
   public void grow(HtmlizableI o)
   {
      if(!objects.contains(o) && o!=null)
         o.grow(this);
   }

   /**
		When you need to print the page...
   */
   public String toString()
   {
      StringBuffer html=new StringBuffer();

		html.append("<html><body>");

		html.append("<h2>"+super.toString()+"</h2><br>containing: "+objects.size()+" objects<hr>");

      Object o;
      Enumeration e=objects.elements();
      while(e.hasMoreElements())
      {
         o=e.nextElement();
         if(o instanceof HtmlizableI)
            html.append(((HtmlizableI)o).toHtml());
         else
            html.append(o.toString());
         html.append("<hr>");
      }

	 	html.append("</body></html>");
      return html.toString();
   }

   /**
      experimental GUI
   */
   public void print()
   {
      if(frame==null)
      {
         frame=new JFrame();
         frame.setSize(300,300);
   
         html= new JEditorPane();
         html.setEditable(false);
         html.setContentType("text/html");
   
         frame.getContentPane().add(new JScrollPane(html));
         frame.getContentPane().add(BorderLayout.NORTH,refresh=new JButton("Refresh"));
			refresh.addActionListener(this);

         frame.setVisible(true);
      }

      html.setText(this.toString());
   }

	public void actionPerformed(ActionEvent e)
	{
      html.setText(this.toString());
	}
}
