package htmlstream; //experimental
import java.util.*;
import java.io.*;
import java.lang.reflect.*;

/**
 *	Default implementation of a HtmlizableI object.
 *   @author Andrea Trentini, Daniela Micucci
 */
public class DefaultHtmlizable implements HtmlizableI {
    /**
     *      Builds a HTML representation of this object. Links are NOT followed! <p> Pseudo-code: <br>
     * for every class through the top <br> create string for attributes <br>
     * MIGLIORARE!!! (problema del Vector, provare a mettere Debug.HTML a false e generare)
     */
    public String toHtml() {
        StringBuffer out = new StringBuffer();
        try {
            Class current = getClass();
            int levels = 0;
            do {
                if (levels != 0) out.append("\n<tr><td colspan=2>");
                out.append(Html.OBEGIN);
                out.append(Html.id(hashCode(), current));
                Field[] f = current.getDeclaredFields();
                for (int i = 0; i < f.length; i++) {
                    f[i].setAccessible(true);
                    Object obj = f[i].get(this);
                    if (f[i].getType().isPrimitive() || obj == null)
                        out.append(Html.field(f[i].getName(), "" + obj));
                    else if (obj instanceof HtmlizableI) {
                        if (Debug.DEEP) Html.prt("HTMLIZABLE!!!");
                        out.append(Html.linkfield(f[i].getName(), (HtmlizableI)obj));
                    }
                    else {
                        if (Debug.DEEP) Html.prt("NOT HTMLIZABLE!!!");
                        out.append(Html.linkfield(f[i].getName(), obj));
                    }
                }
                current = current.getSuperclass();
                levels++;
            }
            while (current != Class.forName("java.lang.Object"));
            for (int i = 0; i < levels; i++) {
                out.append("</td></tr>\n");
                out.append(Html.OEND);
            }
        }
        catch (Exception e) {
            Debug.px(e);
        }
        return out.toString();
    }

    /** For every class through the top add <i>this</i> to stream (with every attribute at each level). */
    public HtmlStream grow(HtmlStream hs) {
        hs.add(this); // aggiungo me stesso
        try {
            Class current = getClass();
            do {
                Field[] f = current.getDeclaredFields();
                for (int i = 0; i < f.length; i++) {
                    f[i].setAccessible(true);
                    Object obj = f[i].get(this);
                    if (obj != null) {
                        if (f[i].getType().isPrimitive()) {
                            if (Debug.DEEP)
                                Html.prt("primitive:" + f[i]);
                        }
                        else {
                            if (obj instanceof HtmlizableI) {
                                ((HtmlizableI)obj).grow(hs);
                            }
                            else // potrebbe ancora essere un oggetto complesso (es. Vector)
                            {
                                // pensarla meglio!!!
                                Enumeration e = isComplexUsable(obj);
                                if (e != null) {
                                    while (e.hasMoreElements()) {
                                        Object objinner = e.nextElement();
                                        if (objinner instanceof HtmlizableI)
                                            ((HtmlizableI)objinner).grow(hs);
                                        else
                                            hs.add(objinner);
                                    }
                                }
                            }
                        }
                    }
                }
                current = current.getSuperclass();
            }
            while (current != Class.forName("java.lang.Object"));
        }
        catch (Exception e) {
            Debug.px(e);
        }
        return hs;
    }

    /** Wraps a complex object with something... */
    protected Enumeration isComplexUsable(Object o) {
        //va incapsulato meglio, in un oggetto piu' serio
        //aggiunta dell'objectarray (prima andava)
        //if(o.getClass().isArray())
        //return new ObjectArrayEnumerator((Object[])o);
        //else
        if (o instanceof Vector)
            return ((Vector)o).elements();
        else if (o instanceof Hashtable)
            return ((Hashtable)o).elements();
        return null;
    }

    /** experimental */
    public String toString() {
        if (Debug.HTML)
            //return (new HtmlStream(this)).toString();
                return toHtml();
        else
            return super.toString();
    }

    /** experimental */
    public String toPureString() {
        return super.toString();
    }
}
